import java.util.HashMap;

/**
 * store each links which are visited before into hash map
 */
public class CloseList {
	
	private HashMap<String, Boolean> visitedlinks;
	
	/**
	 * constructor
	 */
	public CloseList () {
		this.visitedlinks = new HashMap<String, Boolean>();
	}
	
	/**
	 * add visited links into hash map
	 */
	public synchronized void addLinks(String url) {
		this.visitedlinks.put(url.replaceAll("$/", ""), true);
	}
	
	/**
	 * remove visited links if it is not http corrected
	 */
	public synchronized void removeLinks(String url) {
		this.visitedlinks.remove(url.replaceAll("$/", ""));
	}
	
	/**
	 * return true if the url visited before
	 */
	public boolean visited(String url) {
		return this.visitedlinks.containsKey(url.replaceAll("$/", ""));
	}
	
	/**
	 * return true if we are already reached the maximum number of crawled page
	 */
	public boolean crawlLimited() {
		Utility util = new Utility();
		return (this.visitedlinks.size() == util.maxNumberOfCrawledLinks);
	}
	
	
}
