import java.io.File;

public class Driver {

	private final static int nthread = 10;
	
	public static void main(String[] args) {
		
		// parse argument
		Utility util = new Utility();
		boolean active = util.argumentParser(args);
		File queryFile = util.queryFile;
		String firstlink = util.firstlinks;
		
		if (active) {
			
			// create work queue object
			Workqueue workQ = new Workqueue(nthread);
			
			// parse input parameter
			Parser parse = new Parser(workQ);
			
			// execute crawl and build inverted index
			parse.invertedindexBuilder(firstlink);
			
			// execute search method
			parse.searchTrigger(queryFile);
			
			// terminate work queue
			workQ.threadStop();
			
		}
		else {
			
			System.out.println("Invalid to access input directory");
			System.exit(1);
		}
	}

}
