import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

/**
 * traverse a web page word by word and ignore non-alphabet words
 */
public class FileParser {
	
	/**
	 * list of html links
	 */
	private ArrayList<String> linklist;
	
	
	public StringBuffer strippedWebpage(StringBuffer page, LinkInfo linkinfo) {
		
		TagStripper stripper = new TagStripper(page);
		
		// get links
		stripper.getLink();
		
		// start stripped
		stripper.stripStart();
		
		linkinfo.title = stripper.title;
		linkinfo.relative = stripper.relative;
//		System.out.println("AAAAA : "+stripper.relative);
		this.linklist = stripper.linklist;
		return stripper.bufHtml;
	}
	
	/**
	 * get the position of each word in the web page
	 * add into inverted index
	 */
	public void builder(StringBuffer page, String url) {
		
		Scanner sc = null;
		String word_string = "";
		Integer counter_position = 0;
		Invertedindex inverted = Invertedindex.getInvertedindex();
		LinkInfo linkinfo = inverted.getLinkData().addURL(url);
		
		sc = new Scanner(strippedWebpage(page, linkinfo).toString());
			
		// Read each word in the file
		while (sc.hasNext()) {
			
			// Replace non-alphanumerics characters
			word_string = (sc.next()).replaceAll("[^A-Za-z0-9]", "").toLowerCase();

			// word must has more than one letter
			if (word_string.length() > 0) {
				
				// calculate position number
				counter_position++;

				// Use the addWord function created in the "Invertedindex" class to add word in to HashMap which is inverted index
				inverted.add(word_string, linkinfo, counter_position);
			}
		}
			
		// Total words of this file
		linkinfo.linklength = counter_position;

		if (sc.equals(null) == false) {
			sc.close();
		}
	}
	
	/**
	 * insert the html links which were found in the work queue 
	 */
	public void scanLink(CloseList closelist, Workqueue queue) {
		
		for (String item : this.linklist) {
			
			if (!closelist.visited(item) && !closelist.crawlLimited()) {
				
				// create runnable class crawl task
				CrawlTask cTask = new CrawlTask();
				cTask.queue = queue;
				cTask.urls = item;
				cTask.closelist = closelist;
				
				// add runnable clss object into work queue
				queue.execute(cTask);
				
				// add this link into hash map
				closelist.addLinks(item);
			}
		}
	}
	
	/**
	 * read query file and perform search from inverted index
	 */
	public HashMap<String, ArrayList<Search.DocLevel>> buildQuery(File queryfile) {
		
		HashMap<String, ArrayList<Search.DocLevel>> result = new HashMap<String, ArrayList<Search.DocLevel>>();
		Search getSearch = new Search();
		
		String str = null;
		
		try {
			
			// Read file
			BufferedReader reader = new BufferedReader(new FileReader(queryfile));
			
			while ((str = reader.readLine()) != null) {
				
				// searhc query word from inverted index
				result.put(str, getSearch.search(str));
			}
		} catch (IOException e) {
			System.out.println("Error : Cannot open query diretory");
		}

		return result;
	}
}
