import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map.Entry;


/**
 * implementation of building inverted index
 */
public class Invertedindex {
	
	// constant instance of invertedindex class for entire program
	private static final Invertedindex constant = new Invertedindex();
	
	// data structure for inverted index
	public HashMap<String, HashMap<Integer, ArrayList<Integer>>> datamap;
	
	// instance of web page
	public LinkData linkdata;
	
	// instance of lock mechanism
	public Lock lock;
	
	//Constructor
	public Invertedindex() {
		this.lock = new Lock();
		this.linkdata = new LinkData();
		this.datamap = new HashMap<String, HashMap<Integer, ArrayList<Integer>>>();
	}
	
	/**
	 * return a instance of inverted index class for entire program
	 */
	public static Invertedindex getInvertedindex() {
		return Invertedindex.constant;
	}
	
	public LinkData getLinkData() {
		return this.linkdata;
	}
	
	// Add word into hashmap to build inverted index
	public void add(String word, LinkInfo linkinfo, int position) {
		
		lock.getWriter();
		
		if (this.datamap.containsKey(word) == false) {  
			
			// Create a new Array List
			ArrayList<Integer> Alist = new ArrayList<Integer>();
			Alist.add(position);
			
			// Create a new HashMap
			HashMap<Integer, ArrayList<Integer>> hmlist = new HashMap<Integer, ArrayList<Integer>>();
			hmlist.put(linkinfo.linkID, Alist);
			
			// Add these new Linked List and HashMap into inverted index
			this.datamap.put(word, hmlist);
//			System.out.println(this.datamap);
			
		}
		// New word was found in the HashMap before
		else { 
			
			// Load the mapped value in the inverted index by key value
			HashMap<Integer, ArrayList<Integer>> hashmaplist = this.datamap.get(word);
			
			// Was found in the different file
			if (hashmaplist.containsKey(linkinfo.linkID) == false) {
				
				// To create new Array List for word's position
				ArrayList<Integer> list_position = new ArrayList<Integer>();
				list_position.add(position);
				
				// To add this new Array List into previous Hashmap which has the document information
				hashmaplist.put(linkinfo.linkID, list_position);
			}
			//Was found in the same file
			else {
				// Load mapped value of word's position by key value of file ID number
				ArrayList<Integer> list_position = hashmaplist.get(linkinfo.linkID);
				
				// Add this new word's position into current Linked List
				list_position.add(position);
			}
		}
		lock.releaseWriter();
	}
}
