import java.util.ArrayList;


/**
 * This class contains mapping between url and linkID
 */
public class LinkData {

	/**
	 * a list of links
	 */
	private ArrayList<LinkInfo> linkinfo;
	
	public LinkData() {
		this.linkinfo = new ArrayList<LinkInfo>();
	}
	
	/**
	 * fetch url from array list
	 */
	public LinkInfo getURL(String url) {
		LinkInfo value = null;
		for (LinkInfo item : this.linkinfo) {
			if (item.linkstr.equals(url)) {
				value = item;
				break;
			}
		}
		return value;
	}
	
	
	/**
	 * add url into doc info
	 */
	public synchronized LinkInfo addURL(String url) {
		LinkInfo info = this.getURL(url);
		if (info == null) {
			int newID = this.linkinfo.size();
			info = new LinkInfo(0, newID, url, "", "");
			this.linkinfo.add(info);
		}
		return info;
	}
	
	public ArrayList<LinkInfo> getResult() {
		return this.linkinfo;
	}
}
