
public class Lock {

	private int numReaders;
	private int numWriters;
	
	public Lock() {
		numReaders = 0;
		numWriters = 0;
	}
	
	public synchronized void getReader() {
		
		while(numWriters > 0) {
			try {
				this.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		numReaders++;
	}
	
	public synchronized void getWriter() {
			
		while (numReaders > 0 || numWriters > 0) {
			try {
				this.wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		numWriters++;
	}
	
	public synchronized void releaseReader() {
		
		numReaders--;
		this.notifyAll();
	}
	
	public synchronized void releaseWriter() {
		
		numWriters--;
		this.notifyAll();
	}
	
}
