import java.io.File;


/**
 * traverse
 * @author Leo
 *
 */
public class Parser {
	
	private Workqueue queue;
	
	public Parser(Workqueue queue) {
		this.queue = queue;
	}
	
	/**
	 * wait for work queue
	 */
	public void checkWorkQueue() {
		
		while (!this.queue.isFinished()) {
			try {
				Thread.sleep(1000);
			}
			catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}
	
	
	
	/**
	 * build inverted index from input urls
	 */
	public void invertedindexBuilder(String firstlink) {
		
		// Use close list to track visited links
		CloseList closelist = new CloseList();
		
		// Create crawler task and put it into work queue
		CrawlTask cTask = new CrawlTask();
		cTask.queue = queue;
		cTask.urls = firstlink;
		cTask.closelist = closelist;
		queue.execute(cTask);
	}
	
	/**
	 * start search method
	 */
	public void searchTrigger(File queryfile) {
		
		// wait all building tasks are done, then start
		checkWorkQueue();
		
		// create runnable class search task
		SearchTask searchTask = new SearchTask();
		searchTask.queue = this.queue;
		searchTask.queryfile = queryfile;
		this.queue.execute(searchTask);
	}
}
