import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * parse argument 
 */
public class Utility {
	
	public File queryFile = null;
	public String firstlinks = "";
	public final int maxNumberOfCrawledLinks = 30;
	public final int nThreads = 10;
	/*
	 * Print the error message
	 */
	public static void Error() {
		System.out.println("Invalid Parameter");
		System.out.println(" Usage : java -cp invertedindex.jar Driver -w 'URL seed page' -q 'query file' ");
		System.exit(1);
	}
	
	/**
	 * return false if url missed the links and http protocol
	 */
	private boolean vaildURL(String url) {
		RegexLibrary regex = new RegexLibrary();
		Pattern p = Pattern.compile(regex.regexHttplink);
		Matcher m = p.matcher(url);
		return m.find();
	}
	
	public boolean argumentParser(String par[]) {

		boolean isValid = true;
		
		if (par.length == 4) {
			
			if (par[0].toLowerCase().equals("-w") == false) {
				Error();
				isValid = false;
			}
			else {
				
				if (par[2].toLowerCase().equals("-q") == false) {
					Error();
					isValid = false;
				}
				else {
					
					// Get links from input parameter
					this.firstlinks = par[1];
					if (!vaildURL(this.firstlinks)) {
						if (!this.firstlinks.startsWith("http://")) {
							this.firstlinks = "http://" + this.firstlinks;
						}
							
						try {
							URL urlConn = new URL(this.firstlinks);
						} catch (MalformedURLException e) {
							isValid = false;
							System.out.println("Input url is not valid");
							System.exit(1);
						}
					}
					// Get query files
					this.queryFile = new File(par[3]);
					if (!this.queryFile.getAbsoluteFile().canRead()) {
						isValid = false;
						System.out.println("Can not read query file");
						System.exit(1);
					}
				}
			}
		}
		else {
			Error();
			isValid = false;
		}

		return isValid;
	}
}
